#!/usr/bin/perl

################################################################################
##    Config 1.0. Configuration Server for an Exim Mailsystem                   #
##    Using DB Framwork for PHP  1.1.                                           #
##    Copyright (C) 2006 Luca Bertoncello                                       #
##    Hartigstrasse, 12 - 01127 Dresden Deutschland                             #
##    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       #
##    http://www.lucabert.de/  http://www.lucabert.com/                         #
##                                                                              #
##    This program is free software; you can redistribute it and/or modify      #
##    it under the terms of the GNU General Public License as published by      #
##    the Free Software Foundation; version 2 of the License.                   #
##                                                                              #
##    This program is distributed in the hope that it will be useful,           #
##    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
##    GNU General Public License for more details.                              #
##                                                                              #
##    You should have received a copy of the GNU General Public License         #
##    along with this program; if not, write to the Free Software               #
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#################################################################################

use DBI;

if($ARGV[0] eq '' || $ARGV[1] eq '')
{
  print "Usage:\nmanageSpam.pl <path to config.inc.php> <path to mail header file in your preferred language>\n";
  exit(-1);
}

open(MAIL, $ARGV[1]);
$mailSubject = <MAIL>;
@mails = <MAIL>;
close(MAIL);
$mailHeader = join('', @mails);

open(CFG, $ARGV[0]);
@cfgs = <CFG>;
close(CFG);
$user = getConfigVar('eximUser', @cfgs);
$dbHost = getConfigVar('dbHost', @cfgs);
$dbUser = getConfigVar('dbUser', @cfgs);
$dbPass = getConfigVar('dbPass', @cfgs);
$dataBase = getConfigVar('dataBase', @cfgs);
$findBin = getConfigVar('findBin', @cfgs);
$yourDomain = getConfigVar('yourDomain', @cfgs);
$configURL = getConfigVar('configURL', @cfgs);
$toDeleteDays = getConfigVar('toDeleteDays', @cfgs);
$admins = getConfigVar('admins', @cfgs);

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$mon++;
$year += 1900;
$currentDate = sprintf("%02d-%02d-%d", $mday, $mon, $year);

$mailSubject =~ s/%%DATELOG%%/$currentDate/g;
$mailHeader =~ s/%%DATELOG%%/$currentDate/g;
$mailHeader =~ s/%%DOMAIN%%/$yourDomain/g;
$mailHeader =~ s/%%URLCONFIG%%/$configURL/g;
$mailHeader =~ s/%%TODELETEDAY%%/$toDeleteDays/g;

($mailDB = DBI->connect("DBI:mysql:dbname=$dataBase;host=$dbHost", $dbUser, $dbPass)) or die DBI::errstr;

$sth = $mailDB->prepare("SELECT accountname, finaldest, CONCAT(aliasname, '\@', domainname) AS result FROM account, aliases, domain WHERE account.id=aliases.accountid AND aliases.domainid=domain.id AND virtual='f' GROUP BY accountname");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $finaldest = $values[1];
  $emailUser = $values[2];
  @spamsToDelete = `$findBin $finaldest/.Spam/cur/ -type f -mtime +$toDeleteDays`;
  foreach $spam (@spamsToDelete)
  {
    $spam =~ s/[\n\r]//g;
    unlink($spam);
  }
  @spams = `$findBin $finaldest/.Spam/new/ -type f`;
  $hasToSend = 0;
  $mailText = $mailHeader;
  foreach $spam (@spams)
  {
    $spam =~ s/[\n\r]//g;
    ($from, $subj) = getInfoFromSpam($spam);
    $mailText .= "Spam message from: $from (Subj: $subj)\n";
    $hasToSend = 1;
    system("mv $spam $finaldest/.Spam/cur/");
  }

  if($hasToSend)
  {
    open(MAIL, "| /usr/lib/sendmail -t");
    print MAIL "From: $admins\n";
    print MAIL "To: $emailUser\n";
    print MAIL "Subject: $mailSubject\n\n";
    print MAIL "$mailText\n";
    close(MAIL);
  }
}
$sth->finish();

$mailDB->disconnect();

sub getInfoFromSpam
{
  my($spamEMail) = @_;

  open(SPAM, $spamEMail);
  $stop = 0;
  while(<SPAM>)
  {
    $_ =~ s/[\n\r]//g;
    $stop = 1 if($_ eq '');
    if($stop == 0)
    {
      $subj = $_ if($_ =~ /^Subject\:/ig);
      $from = $_ if($_ =~ /^From\:/ig);
    }
  }
  close(SPAM);
  $subj =~ s/^Subject\://g;
  $from =~ s/^From\://g;
  $subj =~ s/^\ *//g;
  $from =~ s/^\ *//g;
  return($from, $subj);
}

sub getConfigVar
{
  my($varName, @cfgs) = @_;

  @fs = grep(/\$$varName/, @cfgs);
  $v = $fs[$#fs];
  $v =~ s/[\n\r]//g;
  ($x, $var) = split(/=/, $v);
  $var =~ s/\ //g;
  $var =~ s/\;//g;
  $var =~ s/\'//g;

  return($var);
}
